import logging

#width
ScreenX = 80
#height
ScreenY = 40

DefaultBrightness = 1.0

Serial = "/dev/ttyACM0"

# kills app after some seconds if it sends no data
NoDataTimeout = 40

LogLevel = logging.DEBUG

UseGui = True
GuiScaleFactor = 15

WebHost = "0.0.0.0"
WebPort = 8000

# first app is always running as default    
Apps = [
    {"guiname": "Lines", "name": "lines", "cmd": "apps/lines.py", "persistent": False},
    
    {"guiname": "Flicker", "name": "flicker", "cmd": "apps/flicker"},
    {"guiname": "Pixelflut", "name": "pixelflut", "cmd": "apps/pixelflut", "persistent": True},
    {"guiname": "Pong", "name": "pong", "cmd": "apps/pong.py"},
    {"guiname": "YoutubeDL", "name": "youtubedl", "cmd": "apps/youtubedl.sh", "persistent": False},
    {"guiname": "Show Framebuffer", "name": "fbcp", "cmd": ["apps/fbcp", "/dev/fb0"]},
    {"guiname": "Strobo", "name": "strobo", "cmd": "apps/strobo.py"},
    {"guiname": "Beispiel", "name": "example", "cmd": "apps/example.py"},

    # juergen/pixelfoo
    {"guiname": "Colored noise", "name": "cnoise", "cmd": "apps/cnoise", "persistent": False},
    {"guiname": "Dual Moodlight", "name": "bimood", "cmd": "apps/bimood", "persistent": False},
    {"guiname": "Maze", "name": "maze", "cmd": "apps/maze", "persistent": False},
    {"guiname": "Dual Maze", "name": "dualmaze", "cmd": "apps/dualmaze", "persistent": False, "persistent": False},
    {"guiname": "Predator & Prey", "name": "predprey", "cmd": "apps/predprey", "persistent": False},


    #{"guiname": "Fibonacci Clock", "name": "fibonacci-clock", "cmd": "apps/fibonacci-clock.py"},
    
    #{"guiname": "Stream", "name": "stream", "cmd": "apps/stream.sh", "persistent": False},
    #{"guiname": "Wget Video/Gif/Images", "name": "wget", "cmd": "apps/wget.sh", "persistent": False},
    #{"guiname": "Tetris", "name": "tetris", "cmd": "apps/deckentetris/deckentetris.py", "persistent": False},
    #{"guiname": "SkyScrapper", "name": "sky", "cmd": "apps/weather/main.py"},
    #{"guiname": "Strobo", "name": "strobo", "cmd": "apps/strobo.py", "persistent": False},
    #{"guiname": "Snake", "name": "snake", "cmd": "apps/snake.py", "persistent": False},
    #{"name": "gif", "cmd": "apps/gif.sh"},
    #{"name": "colormap", "cmd": "apps/colormap.py"},
]   

# load additional apps from config/
import os
import os.path
configs = os.listdir("configs/")
import importlib
for config in configs:
    file, ext = os.path.splitext(os.path.basename(config))
    if ext != ".py" or file[0] == "_":
        continue
    modname = "configs."+file
    lib = importlib.import_module(modname)
    Apps += lib.Apps