#!/bin/bash -e

echo "Setting Attributes for script"
chmod +x apps/pong.py
chmod +x apps/strobo.py
chmod +x apps/example.py
chmod +x apps/youtubedl.sh
chmod +x apps/lines.py


echo "Building c/c++ apps"
mkdir -p build/c
pushd build/c
cmake ../../apps/c-src
make
popd
mv -f build/c/fbcp apps/
mv -f  build/c/flicker apps/
mv -f  build/c/pixelflut apps/

if hash cargo 2>/dev/null; then
    echo "Building juergen/pixelfoo"
    # get juergens apps
    mkdir -p external
    pushd external
    if [ ! -d "pixelfoo" ]; then
        git clone https://git.chaospott.de/juergen/pixelfoo.git
    fi
    pushd pixelfoo
    git pull
    cargo build --release
    popd
    popd

    cp -f external/pixelfoo/target/release/cnoise apps/
    cp -f external/pixelfoo/target/release/bimood apps/
    cp -f external/pixelfoo/target/release/predprey apps/
    cp -f external/pixelfoo/target/release/maze apps/
    cp -f external/pixelfoo/target/release/dualmaze apps/
fi

echo "Getting mathpixel"
mkdir -p external
pushd external
if [ ! -d "mathpixel" ]; then
    git clone https://git.chaospott.de/andreas/mathpixel.git
fi
pushd mathpixel
git pull
bash setup.sh
popd
popd

echo "Setup done"
